Subject: Re: linux-next: manual merge of the bpf-next tree with Linus' tree

From: Viktor Malik <[email-masked]>
Date: Tue, 22 Oct 2024 16:15:01 +0200

On 10/22/24 05:07, Andrii Nakryiko wrote:
> On Mon, Oct 21, 2024 at 6:02 PM Stephen Rothwell <[email-masked]> wrote:
>>
>> Hi all,
>>
>> Today's linux-next merge of the bpf-next tree got a conflict in:
>>
>>   tools/testing/selftests/bpf/Makefile
>>
>> between commit:
>>
>>   f91b256644ea ("selftests/bpf: Add test for kfunc module order")
>>
>> from Linus' tree and commit:
>>
>>   c3566ee6c66c ("selftests/bpf: remove test_tcp_check_syncookie")
>>
>> from the bpf-next tree.
>>
>> I fixed it up (see below) and can carry the fix as necessary. This
>> is now fixed as far as linux-next is concerned, but any non trivial
>> conflicts should be mentioned to your upstream maintainer when your tree
>> is submitted for merging.  You may also want to consider cooperating
>> with the maintainer of the conflicting tree to minimise any particularly
>> complex conflicts.
>>
>> --
>> Cheers,
>> Stephen Rothwell
>>
>> diff --cc tools/testing/selftests/bpf/Makefile
>> index 75016962f795,6d15355f1e62..000000000000
>> --- a/tools/testing/selftests/bpf/Makefile
>> +++ b/tools/testing/selftests/bpf/Makefile
>> @@@ -154,11 -153,9 +153,10 @@@ TEST_PROGS_EXTENDED := with_addr.sh
>>
>>   # Compile but not part of 'make run_tests'
>>   TEST_GEN_PROGS_EXTENDED = \
>> -       flow_dissector_load test_flow_dissector test_tcp_check_syncookie_user \
>> -       test_lirc_mode2_user xdping test_cpp runqslower bench bpf_testmod.ko \
>> -       xskxceiver xdp_redirect_multi xdp_synproxy veristat xdp_hw_metadata \
>> -       xdp_features bpf_test_no_cfi.ko bpf_test_modorder_x.ko \
>> -       bpf_test_modorder_y.ko
>> +       flow_dissector_load test_flow_dissector test_lirc_mode2_user xdping \
>> +       test_cpp runqslower bench bpf_testmod.ko xskxceiver xdp_redirect_multi \
>>  -      xdp_synproxy veristat xdp_hw_metadata xdp_features bpf_test_no_cfi.ko
>> ++      xdp_synproxy veristat xdp_hw_metadata xdp_features bpf_test_no_cfi.ko \
>> ++      bpf_test_modorder_x.ko bpf_test_modorder_y.ko
>>
>>   TEST_GEN_FILES += liburandom_read.so urandom_read sign-file uprobe_multi
>>
>> @@@ -301,22 -302,11 +303,24 @@@ $(OUTPUT)/bpf_testmod.ko: $(VMLINUX_BTF
>>   $(OUTPUT)/bpf_test_no_cfi.ko: $(VMLINUX_BTF) $(RESOLVE_BTFIDS) $(wildcard bpf_test_no_cfi/Makefile bpf_test_no_cfi/*.[ch])
>>         $(call msg,MOD,,$@)
>>         $(Q)$(RM) bpf_test_no_cfi/bpf_test_no_cfi.ko # force re-compilation
>> -       $(Q)$(MAKE) $(submake_extras) RESOLVE_BTFIDS=$(RESOLVE_BTFIDS) -C bpf_test_no_cfi
>> +       $(Q)$(MAKE) $(submake_extras) -C bpf_test_no_cfi \
>> +               RESOLVE_BTFIDS=$(RESOLVE_BTFIDS)         \
>> +               EXTRA_CFLAGS='' EXTRA_LDFLAGS=''
>>         $(Q)cp bpf_test_no_cfi/bpf_test_no_cfi.ko $@
>>
>>  +$(OUTPUT)/bpf_test_modorder_x.ko: $(VMLINUX_BTF) $(RESOLVE_BTFIDS) $(wildcard bpf_test_modorder_x/Makefile bpf_test_modorder_x/*.[ch])
>>  +      $(call msg,MOD,,$@)
>>  +      $(Q)$(RM) bpf_test_modorder_x/bpf_test_modorder_x.ko # force re-compilation
>>  +      $(Q)$(MAKE) $(submake_extras) RESOLVE_BTFIDS=$(RESOLVE_BTFIDS) -C bpf_test_modorder_x
>>  +      $(Q)cp bpf_test_modorder_x/bpf_test_modorder_x.ko $@
>>  +
>>  +$(OUTPUT)/bpf_test_modorder_y.ko: $(VMLINUX_BTF) $(RESOLVE_BTFIDS) $(wildcard bpf_test_modorder_y/Makefile bpf_test_modorder_y/*.[ch])
>>  +      $(call msg,MOD,,$@)
>>  +      $(Q)$(RM) bpf_test_modorder_y/bpf_test_modorder_y.ko # force re-compilation
>>  +      $(Q)$(MAKE) $(submake_extras) RESOLVE_BTFIDS=$(RESOLVE_BTFIDS) -C bpf_test_modorder_y
> 
> This and above will need the EXTRA_CFLAGS and EXTRA_LDFLAGS additions
> that we have for bpf_test_no_cfi.ko. For now, I'll unland the patch
> set to avoid this conflict and breakage. We'll reapply once bpf is
> merged into bpf-next. Viktor, please rebase to take into account these
> new modorder.ko additions.

Thanks Andrii.

I rebased my patches on top of the bpf tree, please let me know when I
can resend them for bpf-next.

Viktor

> 
> 
>>  +      $(Q)cp bpf_test_modorder_y/bpf_test_modorder_y.ko $@
>>  +
>>  +
>>   DEFAULT_BPFTOOL := $(HOST_SCRATCH_DIR)/sbin/bpftool
>>   ifneq ($(CROSS_COMPILE),)
>>   CROSS_BPFTOOL := $(SCRATCH_DIR)/sbin/bpftool
>